Reinforcement StirrupRebar: Difference between revisions

From FreeCAD Documentation
No edit summary
 
(56 intermediate revisions by 9 users not shown)
Line 1: Line 1:
<languages/>
{{GuiCommand|Name=Arch Rebar Stirrup|Workbenches=[[Arch Module|Arch]]|MenuLocation=Arch → Rebar tools|Shortcut=None|SeeAlso=[[Arch_Rebar_Helical|Helical Rebar]]}}
<translate>


<!--T:1-->
==Description==
{{Docnav
The {{KEY|[[Image:Arch_Rebar_Stirrup.png|16px]] Stirrup Rebar}} tool allows user to create a stirrup reinforcing bar in the structural element.
|[[Reinforcement_LShapeRebar|LShapeRebar]]
|[[Reinforcement_BentShapeRebar|BentShapeRebar]]
|[[Reinforcement_Workbench|Reinforcement]]
|IconL=Reinforcement_LShapeRebar.svg
|IconR=Reinforcement_BentShapeRebar.svg
|IconC=Reinforcement_Workbench.svg
}}


<!--T:23-->
[[Image:Stirrup.png]]
{{GuiCommand
|Name=Reinforcement StirrupRebar
|MenuLocation=Arch → Rebar tools → Stirrup<br>3D/BIM → Reinforcement tools → Stirrup
|Workbenches=[[Reinforcement_Workbench|Reinforcement]], [[Arch_Workbench|Arch]], [[BIM_Workbench|BIM]]
|Version=0.17
|SeeAlso=
}}


==Description== <!--T:2-->
==How to use==


<!--T:3-->
# Create a [[Arch Structure|structure]] element
The [[Reinforcement_StirrupRebar|Reinforcement StirrupRebar]] tool allows the user to create a set of stirrup reinforcing bars inside an [[Arch_Structure|Arch Structure]] object.
# Select any face of the structure
# Then select {{KEY|[[Image:Arch_Rebar_Stirrup.png|16px]] Stirrup Rebar}} from the rebar tools
# A task panel will pop-out on the left side of the screen as shown below [[Image:StirrupDialog.png]]
# Select the desired orientation
# Give the inputs like left cover, right cover, top cover, bottom, front cover, bent angle, bent factor, rounding and diameter of the rebar
# Select the mode of distribution either amount or spacing
# If spacing is selected, a user can also opt for [[Custom_Spacing|custom spacing]]
# Pick selected face is used to verify or change the face for rebar distribution
# Click {{KEY|OK}} or {{KEY|Apply}} to generate the rebars
# Click {{KEY|Cancel}} to exit the task panel


<!--T:17-->
==Properties==
This tool is part of the [[Reinforcement_Workbench|Reinforcement Workbench]], an [[External_workbenches|external workbench]] that can be installed with the [[Image:Std_AddonMgr.svg|24px]] [[Std_AddonMgr|Addon Manager]].


</translate>
[[Image:Arch_Rebar_Stirrup_example.png|400px]]
<translate>
<!--T:4-->
{{Caption|One set of stirrup reinforcement bars inside an [[Arch Structure|Arch Structure]] object}}

==Usage== <!--T:5-->

<!--T:6-->
# Select any face of a previously created {{Button|[[Image:Arch_Structure.svg|16px]] [[Arch Structure|Arch Structure]]}} object.
# Then select {{Button|[[Image:Reinforcement_StirrupRebar.svg|16px]] [[Reinforcement_StirrupRebar|Stirrup]]}} from the rebar tools.
# A [[Task_panel|task panel]] will pop-out on the left side of the screen as shown below.
# Select the desired orientation.
# Populate the inputs like 'Left Cover', 'Right Cover', 'Top Cover', 'Bottom Cover', 'Front Cover', 'Bent Angle', 'Bent Factor', 'Rounding' and 'Diameter' of the rebar.
# Select the mode of distribution either 'Amount' or 'Spacing'.
#* If 'Spacing' is selected, a user can also opt for [[Reinforcement_Custom_Spacing|custom spacing]].
# {{Button|Pick Selected Face}} is used to verify or change the face for rebar distribution.
# Click {{Button|OK}} or {{Button|Apply}} to generate the rebars.
# Click {{Button|Cancel}} to exit the task panel.

</translate>
[[Image:StirrupDialog.png|250px]]
<translate>
<!--T:18-->
{{Caption|Task panel for the tool}}

==Properties== <!--T:7-->

<!--T:8-->
* {{PropertyData|Front Cover}}: The distance between rebar and selected face.
* {{PropertyData|Front Cover}}: The distance between rebar and selected face.
* {{PropertyData|Right Cover}}: The distance between the right end of the rebar to right face of the structure.
* {{PropertyData|Right Cover}}: The distance between the right end of the rebar to right face of the structure.
* {{PropertyData|Left Cover}}: The distance between the left end of the rebar to the left face of the structure.
* {{PropertyData|Left Cover}}: The distance between the left end of the rebar to the left face of the structure.
* {{PropertyData|Cover along}}: These property facilities the user to specify either top or bottom cover.
* {{PropertyData|Bottom Cover}}: The distance between rebar from the bottom face of the structure.
* {{PropertyData|Bottom Cover}}: The distance between rebar from the bottom face of the structure.
* {{PropertyData|Top Cover}}: The distance between rebar from the top face of the structure.
* {{PropertyData|Top Cover}}: The distance between rebar from the top face of the structure.
Line 33: Line 68:
* {{PropertyData|Spacing}}: The distance between the axes of each bar.
* {{PropertyData|Spacing}}: The distance between the axes of each bar.


==Scripting==
==Scripting== <!--T:9-->


<!--T:25-->
The {{KEY|[[Image:Arch_Rebar_Stirrup.png|16px]] Stirrup Rebar}} tool can by used in [[macros]] and from the python console by using the following function:
{{Emphasis|See also:}} [[Arch API|Arch API]], [[Reinforcement API|Reinforcement API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].


<!--T:10-->
The Reinforcement StirrupRebar tool can be used in [[Macros|macros]] and from the [[Python|Python]] console by using the following function:
</translate>
{{Code|code=
{{Code|code=
Rebar = makeStirrup(l_cover, r_cover, t_cover, b_cover, f_cover,
makeStirrup(LeftCover, RightCover, TopCover, BottomCover, FrontCover, BentAngle, BentFactor, Diameter, Rounding, AmountSpacingCheck, AmountSpacingValue, Structure, Facename)
bentAngle, bentFactor, diameter, rounding, amount_spacing_check, amount_spacing_value,
structure=None, facename=None)
}}
}}
<translate>


<!--T:15-->
* Adds a Stirrup reinforcing bar object to the given structural object.
* Creates a {{incode|Rebar}} object from the given {{incode|structure}}, which is an [[Arch Structure|Arch Structure]], and {{incode|facename}}, which is a face of that structure.
* If no Structure and Facename is given, it will take user selected face as input.
** If no {{incode|structure}} nor {{incode|facename}} are given, it will take the user selected face as input.
* Here CoverAlong argument is having type tuple.
* {{incode|l_cover}}, {{incode|r_cover}}, {{incode|t_cover}}, {{incode|b_cover}}, and {{incode|f_cover}} are inner offset distances for the rebar elements with respect to the faces of the structure. They are respectively the left, right, top, bottom, and front offsets.
* Returns the new Rebar object.
* {{incode|diameter}} is the diameter of the reinforcement bars inside the structure.
* {{incode|rounding}} is the parameter that determines the bending radius of the reinforcement bars as they make a loop.
* {{incode|bentLength}} and {{incode|bentAngle}} define the length and angle of the tip of the reinforcement loop.
* {{incode|amount_spacing_check}} if it is {{incode|True}} it will create as many reinforcement loops as given by {{incode|amount_spacing_value}}; if it is {{incode|False}} it will create reinforcement loops separated by the numerical value of {{incode|amount_spacing_value}}.
* {{incode|amount_spacing_value}} specifies the number of reinforcement loops, or the value of the separation between them, depending on {{incode|amount_spacing_check}}.


Example:
=== Example === <!--T:13-->

Creating Stirrup rebar.
</translate>
{{Code|code=
{{Code|code=
import Arch, Stirrup
import Draft, Arch, Stirrup

structure = Arch.makeStructure(length=1000.0, width=400.0, height=400.0)
# It doesn't work if the structure is not based on a face
structure.ViewObject.Transparency = 80
# Structure = Arch.makeStructure(length=1000, width=400, height=400)

Rect = Draft.makeRectangle(400, 400)
Structure = Arch.makeStructure(Rect, height=1600)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()
FreeCAD.ActiveDocument.recompute()

rebar = Stirrup.makeStirrup(20, 20, 20, 20, 20, 135, 4, 8, 2, True, 10, structure, "Face6")
Rebar = Stirrup.makeStirrup(20, 20, 20, 20, 20,
115, 4, 8, 2, True, 10, Structure, "Face6")
}}
}}
<translate>


Changing properties of Stirrup rebar.
=== Edition of the rebar === <!--T:26-->

<!--T:14-->
You can change the properties of the rebar with the following function:

</translate>
{{Code|code=
editStirrup(Rebar, l_cover, r_cover, t_cover, b_cover, f_cover,
bentAngle, bentFactor, diameter, rounding, amount_spacing_check, amount_spacing_value,
structure=None, facename=None)
}}
<translate>

<!--T:19-->
* {{incode|Rebar}} is a previously created {{incode|StirrupRebar}} object.
* The other parameters are the same as required by the {{incode|makeStirrup()}} function.
* {{incode|structure}} and {{incode|facename}} may be omitted so that the rebar stays in the original structure.

</translate>
{{Code|code=
{{Code|code=
import Stirrup
import Stirrup

Stirrup.editStirrup(rebar, 20, 20, 20, 20, 50, 90, 4, 8, 2, True, 6, structure, "Face6")
Stirrup.editStirrup(Rebar, 20, 20, 20, 20, 50,
100, 4, 14, 8, True, 8)
}}
}}
<translate>


<!--T:16-->
{{Docnav
|[[Reinforcement_LShapeRebar|LShapeRebar]]
|[[Reinforcement_BentShapeRebar|BentShapeRebar]]
|[[Reinforcement_Workbench|Reinforcement]]
|IconL=Reinforcement_LShapeRebar.svg
|IconR=Reinforcement_BentShapeRebar.svg
|IconC=Reinforcement_Workbench.svg
}}

</translate>
[[Category:External_Command_Reference{{#translation:}}]]
[[Category:Reinforcement{{#translation:}}]]
{{Arch_Tools_navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 12:33, 17 March 2024

Reinforcement StirrupRebar

Menu location
Arch → Rebar tools → Stirrup
3D/BIM → Reinforcement tools → Stirrup
Workbenches
Reinforcement, Arch, BIM
Default shortcut
None
Introduced in version
0.17
See also
None

Description

The Reinforcement StirrupRebar tool allows the user to create a set of stirrup reinforcing bars inside an Arch Structure object.

This tool is part of the Reinforcement Workbench, an external workbench that can be installed with the Addon Manager.

One set of stirrup reinforcement bars inside an Arch Structure object

Usage

  1. Select any face of a previously created Arch Structure object.
  2. Then select Stirrup from the rebar tools.
  3. A task panel will pop-out on the left side of the screen as shown below.
  4. Select the desired orientation.
  5. Populate the inputs like 'Left Cover', 'Right Cover', 'Top Cover', 'Bottom Cover', 'Front Cover', 'Bent Angle', 'Bent Factor', 'Rounding' and 'Diameter' of the rebar.
  6. Select the mode of distribution either 'Amount' or 'Spacing'.
  7. Pick Selected Face is used to verify or change the face for rebar distribution.
  8. Click OK or Apply to generate the rebars.
  9. Click Cancel to exit the task panel.

Task panel for the tool

Properties

  • DataFront Cover: The distance between rebar and selected face.
  • DataRight Cover: The distance between the right end of the rebar to right face of the structure.
  • DataLeft Cover: The distance between the left end of the rebar to the left face of the structure.
  • DataBottom Cover: The distance between rebar from the bottom face of the structure.
  • DataTop Cover: The distance between rebar from the top face of the structure.
  • DataBent Angle: Bent angle defines the angle at the ends of a stirrup.
  • DataBent Factor: Bent Factor defines length of stirrup end.
  • DataAmount: The amount of rebars.
  • DataSpacing: The distance between the axes of each bar.

Scripting

See also: Arch API, Reinforcement API and FreeCAD Scripting Basics.

The Reinforcement StirrupRebar tool can be used in macros and from the Python console by using the following function:

Rebar = makeStirrup(l_cover, r_cover, t_cover, b_cover, f_cover,
                    bentAngle, bentFactor, diameter, rounding, amount_spacing_check, amount_spacing_value,
                    structure=None, facename=None)
  • Creates a Rebar object from the given structure, which is an Arch Structure, and facename, which is a face of that structure.
    • If no structure nor facename are given, it will take the user selected face as input.
  • l_cover, r_cover, t_cover, b_cover, and f_cover are inner offset distances for the rebar elements with respect to the faces of the structure. They are respectively the left, right, top, bottom, and front offsets.
  • diameter is the diameter of the reinforcement bars inside the structure.
  • rounding is the parameter that determines the bending radius of the reinforcement bars as they make a loop.
  • bentLength and bentAngle define the length and angle of the tip of the reinforcement loop.
  • amount_spacing_check if it is True it will create as many reinforcement loops as given by amount_spacing_value; if it is False it will create reinforcement loops separated by the numerical value of amount_spacing_value.
  • amount_spacing_value specifies the number of reinforcement loops, or the value of the separation between them, depending on amount_spacing_check.

Example

import Draft, Arch, Stirrup

# It doesn't work if the structure is not based on a face
# Structure = Arch.makeStructure(length=1000, width=400, height=400)

Rect = Draft.makeRectangle(400, 400)
Structure = Arch.makeStructure(Rect, height=1600)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()

Rebar = Stirrup.makeStirrup(20, 20, 20, 20, 20,
                            115, 4, 8, 2, True, 10, Structure, "Face6")

Edition of the rebar

You can change the properties of the rebar with the following function:

editStirrup(Rebar, l_cover, r_cover, t_cover, b_cover, f_cover,
            bentAngle, bentFactor, diameter, rounding, amount_spacing_check, amount_spacing_value,
            structure=None, facename=None)
  • Rebar is a previously created StirrupRebar object.
  • The other parameters are the same as required by the makeStirrup() function.
  • structure and facename may be omitted so that the rebar stays in the original structure.
import Stirrup

Stirrup.editStirrup(Rebar, 20, 20, 20, 20, 50,
                    100, 4, 14, 8, True, 8)